<?PHP

  if(!isset($PHP_AUTH_USER)) {
    Header("WWW-Authenticate: Basic realm=\"intranet\"");
    Header("HTTP/1.0 401 Unauthorized");
    echo "Text to send if user hits Cancel button\n";
    exit;
   }

  include("ldap.php3");

  $dn=urldecode($dn);

  $ds=ldap_connect($def_ldap_server);
  $user_dn = ldap_get_uid_dn($PHP_AUTH_USER, $ds);
  $r=ldap_bind($ds, $user_dn, $PHP_AUTH_PW);
  $sr=ldap_search($ds, $dn, "(objectclass=*)");
  $info = ldap_get_entries($ds, $sr);
  printf("OB: %d<BR>", $info["count"]);
  printf("%s<br>", $lc_attr_string);
  $attrarray = ldap_array_from_attr($lc_attr_string);
  $attrclass = ldap_class_from_attr($lc_attr_string);
  $attrlist  = ldap_oc_attr_list($attrclass, $ds);
  reset($attrarray);
  printf("<TT>");
  for ($i=0; $i<count($attrarray); $i++) 
   {
    $key   = key($attrarray);
    if (strtolower($attrlist[$key]["multi"]) == "y")
     { 
      printf("%s is multi-valued attribute<br>", $key);
      $add_count = 0;
      $delete_count = 0;
      for ($j=0; $j<(count($attrarray["$key"]) - 1); $j++)
       {
        $new_value = $attrarray[$key][$j];
        $old_value = $info[0]["$key"][$j];
        if ($new_value == $old_value)
          {
           printf("<FONT COLOR=BLUE>Attribute pair is unchanged.</FONT><br>");
          } else {
              printf("<FONT COLOR=RED>");
              printf("Attribute pair has changed<br>");
              if (strlen($new_value) == 0)
               {
                printf("We should DELETE this attribute.<br>");
                $delete_entries["$key"][$delete_count] = $old_value;
                $delete_count++;
               } else {
                   printf("We should DELETE this attribute.<br>");
                   $delete_entries["$key"][$delete_count] = $old_value;
                   $delete_count++;
                   printf("We should ADD this attribute.<br>");
                   $add_entries["$key"][$add_count] = $new_value;
                   $add_count++;
                  }        
             }
       }
      $new_value = $attrarray[$key][$j];
      if (strlen($new_value) > 0) 
       {
        $add_entries["$key"][$add_count] = $new_value;
       }
     } else 
        {
         $new_value = $attrarray[$key][0];
         $old_value = $info[0]["$key"][0];
         if ($new_value == "*NULL*") $new_value = "";
         next($attrarray);
         printf("<FONT COLOR=BLACK>");
         printf("<U>Checking attribute pair %s:%s to %s.</U><BR>",
           $key, $new_value, $old_value);
         printf("</FONT>");
         if ($new_value == $old_value) 
          {
           printf("<FONT COLOR=BLUE>Attribute pair is unchanged.</FONT><br>");
          } else { 
              printf("<FONT COLOR=RED>");
              printf("Attribute pair has changed<br>");
              if ((strlen($old_value) == 0) and (strlen($new_value) > 0))
               {
                printf("We should ADD this attribute.<br>");
                $add_entries["$key"][0] = $new_value;
               } else 
                   if ((strlen($old_value) > 0) and (strlen($new_value) == 0))
                    {
                     printf("We should DELETE this attribute.<br>");
                     $delete_entries["$key"][0] = $old_value;
                    } else {
                        printf("We should MODIFY this attribute.<br>");
                        $change_entries["$key"][0] = $new_value;
                       }
              printf("</FONT>");
             }
        }
   }
  printf("<FONT COLOR=GREEN><U>Operations:</U><br>");

  printf("%s", ldap_process_changes($dn, $add_entries,
                                         $change_entries,
                                         $delete_entries, $ds));

  ldap_close($ds);
  printf("</FONT>");
  printf("<br>");
  $dn = urlencode($dn);
  printf("<A HREF=\"object_form.php3?dn=%s&lc_oc=%s&lc_action=update\">",
    $dn, $attrclass);
  printf("Return to Form</A><br>");
  printf("<A HREF=\"objectclass_select.php3\">Class Selection</A>");
?>
